Bug 1540478 - Change quota option of many volumes concurrently, some commit operation failed. [NEEDINFO]
Summary: Change quota option of many volumes concurrently, some commit operation failed.
Keywords:
Status: CLOSED UPSTREAM
Alias: None
Product: GlusterFS
Classification: Community
Component: quota
Version: mainline
Hardware: All
OS: Linux
high
medium
Target Milestone: ---
Assignee: Sunkwan Kwon
QA Contact: Rahul Hinduja
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-01-31 07:53 UTC by Sunkwan Kwon
Modified: 2020-03-12 12:39 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-03-12 12:39:54 UTC
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
ykaul: needinfo? (sunkwan.kwon)


Attachments (Terms of Use)

Description Sunkwan Kwon 2018-01-31 07:53:06 UTC
Description of problem:
When enable or disable quota, quotad service will be restarted
in order to reload the changes. But this logic can make a problem
when multiple quota requests are sent concurrently.
Some commit operation could be failed and there might be inconsistent
of quota status among replicas.
To avoid this situation, reload the quotad and glustershd service
instead of restarting when needed.

Version-Release number of selected component (if applicable):
3.13 and master branch also

How reproducible:
Enable quota of number of volumes concurrently and check the consistency of quota status among each nodes.

Steps to Reproduce:
1. prepare a gluster cluster consist of three nodes.
2. create 50 volumes with three replicas.
3. start 50 volumes concurrently.
4. enable quota of the volumes concurrently.
5. retrieve number of volumes that have a `features.quota: on` option from each node.
6. check there is inconsistency of quota status among each nodes.

Actual results:
Therea are inconsistency of number of volumes that have a 'features.quota: on' option among each nodes.

Expected results:
Number of volumes that have a `features.quota: on` option of all of replica nodes have to be same.

Additional info:
In this case, below error message was written in glusterd.log file.
```
E [MSGID: 106122] [glusterd-syncop.c:1482:gd_commit_op_phase] 0-management: Commit of operation 'Volume Quota' failed on localhost
```

Comment 2 Sunkwan Kwon 2018-01-31 08:03:14 UTC
I've Submitted a patch for this bug.
Please refer to that.

https://review.gluster.org/#/c/19398/

Comment 3 Amar Tumballi 2019-06-18 10:20:19 UTC
Reopened the patch (it was abandon'd due to inactivity). Needs a rebase, as there are merge conflicts.

Comment 4 Yaniv Kaul 2019-07-14 13:59:54 UTC
Can you rebase your patch?

Comment 5 Worker Ant 2020-03-12 12:39:54 UTC
This bug is moved to https://github.com/gluster/glusterfs/issues/923, and will be tracked there from now on. Visit GitHub issues URL for further details


Note You need to log in before you can comment on or make changes to this bug.